/*
	Specter.h
	This header file contains all of the essential includes for a project made using the Specter library.
	Should be included into your main project files.

	GWM -- Feb 2022
*/
#ifndef SPECTER_H
#define SPECTER_H


#include <iostream>
#include <fstream>
#include <memory>
#include <utility>
#include <algorithm>
#include <functional>

#include <string>
#include <sstream>
#include <vector>
#include <unordered_map>
#include <unordered_set>

#include <cstdint>

#include "Specter/Core/Logger.h"
#include "Specter/Core/Application.h"
#include "Specter/Physics/PhysicsLayer.h"
#include "Specter/Physics/AnalysisStage.h"
#include "Specter/Core/Parameter.h"
#include "Specter/Core/SpectrumManager.h"
#include "Specter/Core/Layer.h"
#include "Specter/Events/Event.h"
#include "Specter/Utils/TestServerLayer.h"
#include "Specter/Utils/Instrumentor.h"
#include "Specter/Utils/Functions.h"
#include "Specter/Utils/RandomGenerator.h"

#endif
